# -*- coding: utf-8 -*-
"""
Created on Tue Jul 12 10:59:11 2022

@author: User
"""

import matplotlib.pyplot as plt
import numpy as np
from scipy.signal import hilbert



# # =============================================================================
# # Pas de dispersion : vphi = cte
# # =============================================================================

vphi = 1.

# =============================================================================
# Tracé de l'amplitude en fonction de la fréquence
# =============================================================================

f_min = 0  # limites  du spectre
f_max = 10 # limites  du spectre

Nf = 1000
df = (f_max-f_min)/Nf


f0 = 4         # fréquence centrale du paquet d'onde
deltaf = 0.5   # élargissement du paquet d'onde

def amplitude(f,f0,deltaf):
    return np.exp(-((f-f0)/deltaf)**2)
    



# Nf = 1000
# F = np.linspace(f_min,f_max,Nf, endpoint=False)
# Amp = amplitude(F,f0,deltaf)
# plt.plot(F,Amp)
# plt.title('Amplitude en fonction de la fréquence')
# plt.show()

# # # =============================================================================
# # # Définition du paquet d'onde
# # # =============================================================================

# def Paquet_onde(x,t):
#     S = 0
#     for i in range(1,Nf):
#         f = f_min +i*df
#         S = S + amplitude(f,f0,deltaf)*np.cos(2*np.pi*f*(t-x/vphi))
#     return S



# x_min = 0
# x_max = 10
# Nx = 1000

# X = np.linspace(x_min,x_max,Nx)

# t = 1.5
# P1 = Paquet_onde(X,t)
# plt.plot(X,P1,color = 'b',label = ' t = 1.5')

# t = 7.5
# P2 = Paquet_onde(X,t)
# plt.plot(X,P2,color = 'r',label = ' t = 5.5')

# plt.title("Paquet d'onde pour t = 1.5 et t = 5.5 - Pas de dispersion")
# plt.legend()

# plt.show()



# # =============================================================================
# # Avec dispersion : Vitesse de phase de la forme c/sqrt(1-(omega_c**2/omega)**2)
# # Paquet d'onde gaussien
# # =============================================================================

f_min = 0  # limites  du spectre
f_max = 10 # limites  du spectre

Nf = 1000
df = (f_max-f_min)/Nf

f0 = 4         # fréquence centrale du paquet d'onde
deltaf = 0.5   # élargissement du paquet d'onde

def amplitude(f,f0,deltaf):
    return np.exp(-((f-f0)/deltaf)**2)

def Paquet_onde(x,t):
    
    fc = 3
    c = 0.6

    S = 0
    
    for i in range(1,Nf):
        f = f_min +i*df

        if f > fc : 
            vphi = c/np.sqrt(1-(fc/f)**2)
            S = S+ amplitude(f,f0,deltaf)*np.cos(2*np.pi*f*(t-x/vphi))    
    
    return S

x_min = 0
x_max = 10
Nx = 1000

X = np.linspace(x_min,x_max,Nx)

# =============================================================================
# Tracé du paquet d'onde à deux instants
# =============================================================================

# t = 1.5
# P1 = Paquet_onde(X,t)
# plt.plot(X,P1,color = 'b',label = ' t = 1.5')
# analytic_signal = hilbert(P1)
# amplitude_envelope = np.abs(analytic_signal)
# plt.plot(X,amplitude_envelope,'--',color = 'b')
# plt.plot(X,-amplitude_envelope,'--',color = 'b')


# t = 5.5
# P2 = Paquet_onde(X,t)
# plt.plot(X,P2,color = 'r',label = ' t = 5.5')
# analytic_signal = hilbert(P2)
# amplitude_envelope = np.abs(analytic_signal)
# plt.plot(X,amplitude_envelope,'--',color = 'r')
# plt.plot(X,-amplitude_envelope,'--',color = 'r')

# plt.title("Paquet d'onde pour t = 1.5 et t = 5.5 - Avec dispersion")
# plt.legend()

# plt.show()




# =============================================================================
# Évolution de l'enveloppe
# =============================================================================
# for t in [0.1,2.5,5,7.5,10,12.5,15,17.5,20]:
#       P = Paquet_onde(X,t)
#       # plt.plot(X,P,color = 'b')
#       analytic_signal = hilbert(P)
#       amplitude_envelope = np.abs(analytic_signal)
#       plt.plot(X,amplitude_envelope,'--',color = 'r')
#       plt.plot(X,-amplitude_envelope,'--',color = 'r')

# plt.title("Paquet d'onde pour t = 0 à t = 20 - Avec dispersion")

# plt.show()   





# # =============================================================================
# # Animation du paquet d'onde
# # =============================================================================
    
import matplotlib.animation as animation

fig = plt.figure(num=0,figsize=(12,12))
a0=plt.subplot2grid((1,1),(0,0))
a0.set_xlim(-1,10)
a0.set_ylim(-100,100)
a0.grid(True)
a0.set_title('Propagation avec dispersion')
#a0.set_aspect('equal', 'box')


f_min = 0  # limites  du spectre
f_max = 10 # limites  du spectre

Nf = 1000
df = (f_max-f_min)/Nf

f0 = 4         # fréquence centrale du paquet d'onde
deltaf = 0.5   # élargissement du paquet d'onde

def amplitude(f,f0,deltaf):
    return np.exp(-((f-f0)/deltaf)**2)

def Paquet_onde(x,t):
    
    fc = 3
    c = 0.6

    S = 0
    
    for i in range(1,Nf):
        f = f_min +i*df

        if f > fc : 
            vphi = c/np.sqrt(1-(fc/f)**2)
            S = S+ amplitude(f,f0,deltaf)*np.cos(2*np.pi*f*(t-x/vphi))    
    
    return S


def Enveloppe_p(P):
    analytic_signal = hilbert(P)
    return  np.abs(analytic_signal)

    
def Sommet(t):
    
    Pmax_x0 = 0
    fc = 3
    c = 0.6
    f0 = 4
    
    vg =  c*np.sqrt(1-(fc/f0)**2)
    
    return Pmax_x0 + vg*t

x_min = 0
x_max = 10
Nx = 1000
X = np.linspace(x_min,x_max,Nx)

t_min = 0
t_max = 20
Nt = 500
dt = (t_max-t_min)/Nt


line, = a0.plot([],[],linewidth=3,color='b') 
line_env_p, = a0.plot([],[],'--',linewidth=1,color='r')
line_env_m, = a0.plot([],[],'--',linewidth=1,color='r')
line_sommet, = a0.plot([],[],linewidth=2,color='g') 

def init():
     
    P = Paquet_onde(X,t_min)
    
    E_P = Enveloppe_p(P)
    E_M = (-1)*E_P
    

    S = Sommet(t_min)
    line.set_data(X,P)
    line_env_p.set_data(X,E_P)
    line_env_m.set_data(X,E_M)
    line_sommet, = a0.plot([S,S],[-100,100],linewidth=3,color='g') 
    
    return line,line_sommet,line_env_p,line_env_m



def animate(j): 
    
    t = t_min + (j+1)*dt
    P = Paquet_onde(X,t)
    
    E_P = Enveloppe_p(P)
    E_M = (-1)*E_P

    
    S = Sommet(t)
    line.set_data(X,P)
    line_env_p.set_data(X,E_P)
    line_env_m.set_data(X,E_M)
    
    line_sommet, = a0.plot([S,S],[-100,100],linewidth=3,color='g') 
    return line,line_sommet,line_env_p,line_env_m 
    


 
ani = animation.FuncAnimation(fig, animate, init_func=init, frames=Nt, blit=True, interval=20, repeat=False)
plt.show()
